/*----- PROTECTED REGION ID(DsAxis.h) ENABLED START -----*/
//=============================================================================
//
// file :        DsAxis.h
//
// description : Include for the DsAxis class.
//
// project :     DsAxis.
//
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef DSAXIS_H
#define DSAXIS_H


#include <tango.h>

#include "History.h"

/*----- PROTECTED REGION END -----*/	//	DsAxis.h

/**
 *  DsAxis class description:
 *    Pin hole - double slit motion server
 */

namespace DsAxis_ns
{
/*----- PROTECTED REGION ID(DsAxis::Additional Class Declarations) ENABLED START -----*/

	class DsAxisHandler;

	/*----- PROTECTED REGION END -----*/	//	DsAxis::Additional Class Declarations

class DsAxis : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(DsAxis::Data Members) ENABLED START -----*/

	//	First cone horizontal axis
	DsAxisHandler* h1_axis;

	//	First cone vertical axis
	DsAxisHandler* v1_axis;

	//	Second cone horizontal axis
	DsAxisHandler* h2_axis;

	//	Second cone vertical axis
	DsAxisHandler* v2_axis;

	//	Horizontal motion accuracy
	double h_motion_accuracy;

	//	Vertical motion accuracy
	double v_motion_accuracy;

	//	Initialization completed without errors
	bool init_completed;

	//	Current back off
	double current_back_off;

	//	Last exception time stamp
	time_t last_exception_t;

private:

	History_ns::history* hist;

	/*----- PROTECTED REGION END -----*/	//	DsAxis::Data Members

//	Device property data members
public:
	//	AxisH1:	Double slit first cone horizontal axis
	string	axisH1;
	//	AxisV1:	Double slit first cone vertical axis
	string	axisV1;
	//	AxisH2:	Double slit second cone horizontal axis
	string	axisH2;
	//	AxisV2:	Double slit second cone vertical axis
	string	axisV2;
	//	Timeout:	
	Tango::DevULong	timeout;
	//	MaxBackOff:	
	Tango::DevUShort	maxBackOff;
	//	CenterToBorderDistance:	
	Tango::DevUShort	centerToBorderDistance;
	//	PositionAttribute:	For all axis
	string	positionAttribute;
	//	MotionAccuracyAttribute:	
	string	motionAccuracyAttribute;
	//	DSType:	Padres
	//  Simple
	string	dSType;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_AxisPositionH1_read;
	Tango::DevDouble	*attr_AxisPositionH2_read;
	Tango::DevDouble	*attr_AxisPositionV1_read;
	Tango::DevDouble	*attr_AxisPositionV2_read;
	Tango::DevShort	*attr_IsInitialisedH1_read;
	Tango::DevShort	*attr_IsInitialisedH2_read;
	Tango::DevShort	*attr_IsInitialisedV1_read;
	Tango::DevShort	*attr_IsInitialisedV2_read;
	Tango::DevDouble	*attr_DSCenterH_read;
	Tango::DevDouble	*attr_DSCenterV_read;
	Tango::DevDouble	*attr_DSGapH_read;
	Tango::DevDouble	*attr_DSGapV_read;
	Tango::DevShort	*attr_DSAxisIsInitialised_read;
	Tango::DevString	*attr_History_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	DsAxis(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	DsAxis(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	DsAxis(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~DsAxis() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : DsAxis::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : DsAxis::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute AxisPositionH1 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisPositionH1(Tango::Attribute &attr);
	virtual void write_AxisPositionH1(Tango::WAttribute &attr);
	virtual bool is_AxisPositionH1_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisPositionH2 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisPositionH2(Tango::Attribute &attr);
	virtual void write_AxisPositionH2(Tango::WAttribute &attr);
	virtual bool is_AxisPositionH2_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisPositionV1 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisPositionV1(Tango::Attribute &attr);
	virtual void write_AxisPositionV1(Tango::WAttribute &attr);
	virtual bool is_AxisPositionV1_allowed(Tango::AttReqType type);
/**
 *	Attribute AxisPositionV2 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AxisPositionV2(Tango::Attribute &attr);
	virtual void write_AxisPositionV2(Tango::WAttribute &attr);
	virtual bool is_AxisPositionV2_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedH1 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedH1(Tango::Attribute &attr);
	virtual bool is_IsInitialisedH1_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedH2 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedH2(Tango::Attribute &attr);
	virtual bool is_IsInitialisedH2_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedV1 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedV1(Tango::Attribute &attr);
	virtual bool is_IsInitialisedV1_allowed(Tango::AttReqType type);
/**
 *	Attribute IsInitialisedV2 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_IsInitialisedV2(Tango::Attribute &attr);
	virtual bool is_IsInitialisedV2_allowed(Tango::AttReqType type);
/**
 *	Attribute DSCenterH related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DSCenterH(Tango::Attribute &attr);
	virtual void write_DSCenterH(Tango::WAttribute &attr);
	virtual bool is_DSCenterH_allowed(Tango::AttReqType type);
/**
 *	Attribute DSCenterV related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DSCenterV(Tango::Attribute &attr);
	virtual void write_DSCenterV(Tango::WAttribute &attr);
	virtual bool is_DSCenterV_allowed(Tango::AttReqType type);
/**
 *	Attribute DSGapH related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DSGapH(Tango::Attribute &attr);
	virtual void write_DSGapH(Tango::WAttribute &attr);
	virtual bool is_DSGapH_allowed(Tango::AttReqType type);
/**
 *	Attribute DSGapV related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DSGapV(Tango::Attribute &attr);
	virtual void write_DSGapV(Tango::WAttribute &attr);
	virtual bool is_DSGapV_allowed(Tango::AttReqType type);
/**
 *	Attribute DSAxisIsInitialised related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_DSAxisIsInitialised(Tango::Attribute &attr);
	virtual bool is_DSAxisIsInitialised_allowed(Tango::AttReqType type);
/**
 *	Attribute History related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
	virtual void read_History(Tango::Attribute &attr);
	virtual bool is_History_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : DsAxis::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command AxisStopH1 related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_h1();
	virtual bool is_AxisStopH1_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopV1 related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_v1();
	virtual bool is_AxisStopV1_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopH2 related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_h2();
	virtual bool is_AxisStopH2_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisStopV2 related method
	 *	Description: 
	 *
	 */
	virtual void axis_stop_v2();
	virtual bool is_AxisStopV2_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitH1 related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_h1();
	virtual bool is_AxisInitH1_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitV1 related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_v1();
	virtual bool is_AxisInitV1_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitH2 related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_h2();
	virtual bool is_AxisInitH2_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInitV2 related method
	 *	Description: 
	 *
	 */
	virtual void axis_init_v2();
	virtual bool is_AxisInitV2_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOnH1 related method
	 *	Description: 
	 *
	 */
	virtual void motor_on_h1();
	virtual bool is_MotorOnH1_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOnV1 related method
	 *	Description: 
	 *
	 */
	virtual void motor_on_v1();
	virtual bool is_MotorOnV1_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOnH2 related method
	 *	Description: 
	 *
	 */
	virtual void motor_on_h2();
	virtual bool is_MotorOnH2_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOnV2 related method
	 *	Description: 
	 *
	 */
	virtual void motor_on_v2();
	virtual bool is_MotorOnV2_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOffH1 related method
	 *	Description: 
	 *
	 */
	virtual void motor_off_h1();
	virtual bool is_MotorOffH1_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOffV1 related method
	 *	Description: 
	 *
	 */
	virtual void motor_off_v1();
	virtual bool is_MotorOffV1_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOffH2 related method
	 *	Description: 
	 *
	 */
	virtual void motor_off_h2();
	virtual bool is_MotorOffH2_allowed(const CORBA::Any &any);
	/**
	 *	Command MotorOffV2 related method
	 *	Description: 
	 *
	 */
	virtual void motor_off_v2();
	virtual bool is_MotorOffV2_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionStatusH1 related method
	 *	Description: 
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_motion_status_h1();
	virtual bool is_GetMotionStatusH1_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionStatusV1 related method
	 *	Description: 
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_motion_status_v1();
	virtual bool is_GetMotionStatusV1_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionStatusH2 related method
	 *	Description: 
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_motion_status_h2();
	virtual bool is_GetMotionStatusH2_allowed(const CORBA::Any &any);
	/**
	 *	Command GetMotionStatusV2 related method
	 *	Description: 
	 *
	 *	@returns 
	 */
	virtual Tango::DevLong get_motion_status_v2();
	virtual bool is_GetMotionStatusV2_allowed(const CORBA::Any &any);
	/**
	 *	Command DSCenterHGoToPosition related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void dscenter_hgo_to_position(Tango::DevDouble argin);
	virtual bool is_DSCenterHGoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command DSCenterVGoToPosition related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void dscenter_vgo_to_position(Tango::DevDouble argin);
	virtual bool is_DSCenterVGoToPosition_allowed(const CORBA::Any &any);
	/**
	 *	Command DSGapH related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void dsgap_h(Tango::DevDouble argin);
	virtual bool is_DSGapH_allowed(const CORBA::Any &any);
	/**
	 *	Command DSGapV related method
	 *	Description: 
	 *
	 *	@param argin 
	 */
	virtual void dsgap_v(Tango::DevDouble argin);
	virtual bool is_DSGapV_allowed(const CORBA::Any &any);
	/**
	 *	Command DSAxisStop related method
	 *	Description: 
	 *
	 */
	virtual void dsaxis_stop();
	virtual bool is_DSAxisStop_allowed(const CORBA::Any &any);
	/**
	 *	Command DSAxisInit related method
	 *	Description: 
	 *
	 */
	virtual void dsaxis_init();
	virtual bool is_DSAxisInit_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : DsAxis::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(DsAxis::Additional Method prototypes) ENABLED START -----*/

	virtual Tango::DevDouble calculate_center(Tango::DevDouble, Tango::DevDouble);
	virtual Tango::DevDouble calculate_gap(Tango::DevDouble, Tango::DevDouble);

	virtual bool update_allowed();
	virtual void update_state();
	virtual void update_status();

	virtual void exception_handler(Tango::DevFailed &, Tango::DevState, const std::string);

	/*----- PROTECTED REGION END -----*/	//	DsAxis::Additional Method prototypes
};

/*----- PROTECTED REGION ID(DsAxis::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	DsAxis::Additional Classes Definitions

}	//	End of namespace

#endif   //	DsAxis_H
