/*----- PROTECTED REGION ID(DsAxisClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        DsAxisClass.cpp
//
// description : C++ source for the DsAxisClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     DsAxis.
//
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <DsAxisClass.h>

/*----- PROTECTED REGION END -----*/	//	DsAxisClass.cpp

//-------------------------------------------------------------------
/**
 *	Create DsAxisClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_DsAxis_class(const char *name) {
		return DsAxis_ns::DsAxisClass::init(name);
	}
}

namespace DsAxis_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
DsAxisClass *DsAxisClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		DsAxisClass::DsAxisClass(string &s)
 * description : 	constructor for the DsAxisClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
DsAxisClass::DsAxisClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering DsAxisClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(DsAxisClass::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::constructor

	cout2 << "Leaving DsAxisClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		DsAxisClass::~DsAxisClass()
 * description : 	destructor for the DsAxisClass
 */
//--------------------------------------------------------
DsAxisClass::~DsAxisClass()
{
	/*----- PROTECTED REGION ID(DsAxisClass::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		DsAxisClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
DsAxisClass *DsAxisClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new DsAxisClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		DsAxisClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
DsAxisClass *DsAxisClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		AxisStopH1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopH1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopH1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_stop_h1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopV1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopV1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopV1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_stop_v1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopH2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopH2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopH2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_stop_h2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisStopV2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisStopV2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisStopV2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_stop_v2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitH1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitH1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitH1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_init_h1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitV1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitV1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitV1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_init_v1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitH2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitH2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitH2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_init_h2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		AxisInitV2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitV2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitV2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->axis_init_v2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOnH1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOnH1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOnH1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_on_h1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOnV1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOnV1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOnV1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_on_v1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOnH2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOnH2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOnH2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_on_h2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOnV2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOnV2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOnV2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_on_v2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOffH1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOffH1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOffH1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_off_h1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOffV1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOffV1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOffV1Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_off_v1());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOffH2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOffH2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOffH2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_off_h2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		MotorOffV2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *MotorOffV2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "MotorOffV2Class::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->motor_off_v2());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		GetMotionStatusH1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionStatusH1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionStatusH1Class::execute(): arrived" << endl;
	return insert((static_cast<DsAxis *>(device))->get_motion_status_h1());
}

//--------------------------------------------------------
/**
 * method : 		GetMotionStatusV1Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionStatusV1Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionStatusV1Class::execute(): arrived" << endl;
	return insert((static_cast<DsAxis *>(device))->get_motion_status_v1());
}

//--------------------------------------------------------
/**
 * method : 		GetMotionStatusH2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionStatusH2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionStatusH2Class::execute(): arrived" << endl;
	return insert((static_cast<DsAxis *>(device))->get_motion_status_h2());
}

//--------------------------------------------------------
/**
 * method : 		GetMotionStatusV2Class::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetMotionStatusV2Class::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetMotionStatusV2Class::execute(): arrived" << endl;
	return insert((static_cast<DsAxis *>(device))->get_motion_status_v2());
}

//--------------------------------------------------------
/**
 * method : 		DSCenterHGoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSCenterHGoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DSCenterHGoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<DsAxis *>(device))->dscenter_hgo_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DSCenterVGoToPositionClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSCenterVGoToPositionClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DSCenterVGoToPositionClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<DsAxis *>(device))->dscenter_vgo_to_position(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DSGapHClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSGapHClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DSGapHClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<DsAxis *>(device))->dsgap_h(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DSGapVClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSGapVClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "DSGapVClass::execute(): arrived" << endl;
	Tango::DevDouble argin;
	extract(in_any, argin);
	((static_cast<DsAxis *>(device))->dsgap_v(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DSAxisStopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSAxisStopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DSAxisStopClass::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->dsaxis_stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		DSAxisInitClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *DSAxisInitClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "DSAxisInitClass::execute(): arrived" << endl;
	((static_cast<DsAxis *>(device))->dsaxis_init());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum DsAxisClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum DsAxisClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum DsAxisClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void DsAxisClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "AxisH1";
	prop_desc = "Double slit first cone horizontal axis";
	prop_def  = "undefined";
	vect_data.clear();
	vect_data.push_back("undefined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisV1";
	prop_desc = "Double slit first cone vertical axis";
	prop_def  = "undefined";
	vect_data.clear();
	vect_data.push_back("undefined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisH2";
	prop_desc = "Double slit second cone horizontal axis";
	prop_def  = "undefined";
	vect_data.clear();
	vect_data.push_back("undefined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "AxisV2";
	prop_desc = "Double slit second cone vertical axis";
	prop_def  = "undefined";
	vect_data.clear();
	vect_data.push_back("undefined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeout";
	prop_desc = "";
	prop_def  = "1500";
	vect_data.clear();
	vect_data.push_back("1500");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MaxBackOff";
	prop_desc = "";
	prop_def  = "60";
	vect_data.clear();
	vect_data.push_back("60");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CenterToBorderDistance";
	prop_desc = "";
	prop_def  = "10";
	vect_data.clear();
	vect_data.push_back("10");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "PositionAttribute";
	prop_desc = "For all axis";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MotionAccuracyAttribute";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DSType";
	prop_desc = "Padres\nSimple";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void DsAxisClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("DsAxis");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Pin hole - double slit motion server");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void DsAxisClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(DsAxisClass::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new DsAxis(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		DsAxis *dev = static_cast<DsAxis *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(DsAxisClass::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void DsAxisClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(DsAxisClass::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::attribute_factory_before
	//	Attribute : AxisPositionH1
	AxisPositionH1Attrib	*axispositionh1 = new AxisPositionH1Attrib();
	Tango::UserDefaultAttrProp	axispositionh1_prop;
	//	description	not set for AxisPositionH1
	//	label	not set for AxisPositionH1
	//	unit	not set for AxisPositionH1
	//	standard_unit	not set for AxisPositionH1
	//	display_unit	not set for AxisPositionH1
	//	format	not set for AxisPositionH1
	//	max_value	not set for AxisPositionH1
	//	min_value	not set for AxisPositionH1
	//	max_alarm	not set for AxisPositionH1
	//	min_alarm	not set for AxisPositionH1
	//	max_warning	not set for AxisPositionH1
	//	min_warning	not set for AxisPositionH1
	//	delta_t	not set for AxisPositionH1
	//	delta_val	not set for AxisPositionH1
	
	axispositionh1->set_default_properties(axispositionh1_prop);
	//	Not Polled
	axispositionh1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axispositionh1);

	//	Attribute : AxisPositionH2
	AxisPositionH2Attrib	*axispositionh2 = new AxisPositionH2Attrib();
	Tango::UserDefaultAttrProp	axispositionh2_prop;
	//	description	not set for AxisPositionH2
	//	label	not set for AxisPositionH2
	//	unit	not set for AxisPositionH2
	//	standard_unit	not set for AxisPositionH2
	//	display_unit	not set for AxisPositionH2
	//	format	not set for AxisPositionH2
	//	max_value	not set for AxisPositionH2
	//	min_value	not set for AxisPositionH2
	//	max_alarm	not set for AxisPositionH2
	//	min_alarm	not set for AxisPositionH2
	//	max_warning	not set for AxisPositionH2
	//	min_warning	not set for AxisPositionH2
	//	delta_t	not set for AxisPositionH2
	//	delta_val	not set for AxisPositionH2
	
	axispositionh2->set_default_properties(axispositionh2_prop);
	//	Not Polled
	axispositionh2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axispositionh2);

	//	Attribute : AxisPositionV1
	AxisPositionV1Attrib	*axispositionv1 = new AxisPositionV1Attrib();
	Tango::UserDefaultAttrProp	axispositionv1_prop;
	//	description	not set for AxisPositionV1
	//	label	not set for AxisPositionV1
	//	unit	not set for AxisPositionV1
	//	standard_unit	not set for AxisPositionV1
	//	display_unit	not set for AxisPositionV1
	//	format	not set for AxisPositionV1
	//	max_value	not set for AxisPositionV1
	//	min_value	not set for AxisPositionV1
	//	max_alarm	not set for AxisPositionV1
	//	min_alarm	not set for AxisPositionV1
	//	max_warning	not set for AxisPositionV1
	//	min_warning	not set for AxisPositionV1
	//	delta_t	not set for AxisPositionV1
	//	delta_val	not set for AxisPositionV1
	
	axispositionv1->set_default_properties(axispositionv1_prop);
	//	Not Polled
	axispositionv1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axispositionv1);

	//	Attribute : AxisPositionV2
	AxisPositionV2Attrib	*axispositionv2 = new AxisPositionV2Attrib();
	Tango::UserDefaultAttrProp	axispositionv2_prop;
	//	description	not set for AxisPositionV2
	//	label	not set for AxisPositionV2
	//	unit	not set for AxisPositionV2
	//	standard_unit	not set for AxisPositionV2
	//	display_unit	not set for AxisPositionV2
	//	format	not set for AxisPositionV2
	//	max_value	not set for AxisPositionV2
	//	min_value	not set for AxisPositionV2
	//	max_alarm	not set for AxisPositionV2
	//	min_alarm	not set for AxisPositionV2
	//	max_warning	not set for AxisPositionV2
	//	min_warning	not set for AxisPositionV2
	//	delta_t	not set for AxisPositionV2
	//	delta_val	not set for AxisPositionV2
	
	axispositionv2->set_default_properties(axispositionv2_prop);
	//	Not Polled
	axispositionv2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(axispositionv2);

	//	Attribute : IsInitialisedH1
	IsInitialisedH1Attrib	*isinitialisedh1 = new IsInitialisedH1Attrib();
	Tango::UserDefaultAttrProp	isinitialisedh1_prop;
	//	description	not set for IsInitialisedH1
	//	label	not set for IsInitialisedH1
	//	unit	not set for IsInitialisedH1
	//	standard_unit	not set for IsInitialisedH1
	//	display_unit	not set for IsInitialisedH1
	//	format	not set for IsInitialisedH1
	//	max_value	not set for IsInitialisedH1
	//	min_value	not set for IsInitialisedH1
	//	max_alarm	not set for IsInitialisedH1
	//	min_alarm	not set for IsInitialisedH1
	//	max_warning	not set for IsInitialisedH1
	//	min_warning	not set for IsInitialisedH1
	//	delta_t	not set for IsInitialisedH1
	//	delta_val	not set for IsInitialisedH1
	
	isinitialisedh1->set_default_properties(isinitialisedh1_prop);
	//	Not Polled
	isinitialisedh1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedh1);

	//	Attribute : IsInitialisedH2
	IsInitialisedH2Attrib	*isinitialisedh2 = new IsInitialisedH2Attrib();
	Tango::UserDefaultAttrProp	isinitialisedh2_prop;
	//	description	not set for IsInitialisedH2
	//	label	not set for IsInitialisedH2
	//	unit	not set for IsInitialisedH2
	//	standard_unit	not set for IsInitialisedH2
	//	display_unit	not set for IsInitialisedH2
	//	format	not set for IsInitialisedH2
	//	max_value	not set for IsInitialisedH2
	//	min_value	not set for IsInitialisedH2
	//	max_alarm	not set for IsInitialisedH2
	//	min_alarm	not set for IsInitialisedH2
	//	max_warning	not set for IsInitialisedH2
	//	min_warning	not set for IsInitialisedH2
	//	delta_t	not set for IsInitialisedH2
	//	delta_val	not set for IsInitialisedH2
	
	isinitialisedh2->set_default_properties(isinitialisedh2_prop);
	//	Not Polled
	isinitialisedh2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedh2);

	//	Attribute : IsInitialisedV1
	IsInitialisedV1Attrib	*isinitialisedv1 = new IsInitialisedV1Attrib();
	Tango::UserDefaultAttrProp	isinitialisedv1_prop;
	//	description	not set for IsInitialisedV1
	//	label	not set for IsInitialisedV1
	//	unit	not set for IsInitialisedV1
	//	standard_unit	not set for IsInitialisedV1
	//	display_unit	not set for IsInitialisedV1
	//	format	not set for IsInitialisedV1
	//	max_value	not set for IsInitialisedV1
	//	min_value	not set for IsInitialisedV1
	//	max_alarm	not set for IsInitialisedV1
	//	min_alarm	not set for IsInitialisedV1
	//	max_warning	not set for IsInitialisedV1
	//	min_warning	not set for IsInitialisedV1
	//	delta_t	not set for IsInitialisedV1
	//	delta_val	not set for IsInitialisedV1
	
	isinitialisedv1->set_default_properties(isinitialisedv1_prop);
	//	Not Polled
	isinitialisedv1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedv1);

	//	Attribute : IsInitialisedV2
	IsInitialisedV2Attrib	*isinitialisedv2 = new IsInitialisedV2Attrib();
	Tango::UserDefaultAttrProp	isinitialisedv2_prop;
	//	description	not set for IsInitialisedV2
	//	label	not set for IsInitialisedV2
	//	unit	not set for IsInitialisedV2
	//	standard_unit	not set for IsInitialisedV2
	//	display_unit	not set for IsInitialisedV2
	//	format	not set for IsInitialisedV2
	//	max_value	not set for IsInitialisedV2
	//	min_value	not set for IsInitialisedV2
	//	max_alarm	not set for IsInitialisedV2
	//	min_alarm	not set for IsInitialisedV2
	//	max_warning	not set for IsInitialisedV2
	//	min_warning	not set for IsInitialisedV2
	//	delta_t	not set for IsInitialisedV2
	//	delta_val	not set for IsInitialisedV2
	
	isinitialisedv2->set_default_properties(isinitialisedv2_prop);
	//	Not Polled
	isinitialisedv2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(isinitialisedv2);

	//	Attribute : DSCenterH
	DSCenterHAttrib	*dscenterh = new DSCenterHAttrib();
	Tango::UserDefaultAttrProp	dscenterh_prop;
	//	description	not set for DSCenterH
	//	label	not set for DSCenterH
	//	unit	not set for DSCenterH
	//	standard_unit	not set for DSCenterH
	//	display_unit	not set for DSCenterH
	//	format	not set for DSCenterH
	//	max_value	not set for DSCenterH
	//	min_value	not set for DSCenterH
	//	max_alarm	not set for DSCenterH
	//	min_alarm	not set for DSCenterH
	//	max_warning	not set for DSCenterH
	//	min_warning	not set for DSCenterH
	//	delta_t	not set for DSCenterH
	//	delta_val	not set for DSCenterH
	
	dscenterh->set_default_properties(dscenterh_prop);
	//	Not Polled
	dscenterh->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dscenterh);

	//	Attribute : DSCenterV
	DSCenterVAttrib	*dscenterv = new DSCenterVAttrib();
	Tango::UserDefaultAttrProp	dscenterv_prop;
	//	description	not set for DSCenterV
	//	label	not set for DSCenterV
	//	unit	not set for DSCenterV
	//	standard_unit	not set for DSCenterV
	//	display_unit	not set for DSCenterV
	//	format	not set for DSCenterV
	//	max_value	not set for DSCenterV
	//	min_value	not set for DSCenterV
	//	max_alarm	not set for DSCenterV
	//	min_alarm	not set for DSCenterV
	//	max_warning	not set for DSCenterV
	//	min_warning	not set for DSCenterV
	//	delta_t	not set for DSCenterV
	//	delta_val	not set for DSCenterV
	
	dscenterv->set_default_properties(dscenterv_prop);
	//	Not Polled
	dscenterv->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dscenterv);

	//	Attribute : DSGapH
	DSGapHAttrib	*dsgaph = new DSGapHAttrib();
	Tango::UserDefaultAttrProp	dsgaph_prop;
	//	description	not set for DSGapH
	//	label	not set for DSGapH
	//	unit	not set for DSGapH
	//	standard_unit	not set for DSGapH
	//	display_unit	not set for DSGapH
	//	format	not set for DSGapH
	//	max_value	not set for DSGapH
	//	min_value	not set for DSGapH
	//	max_alarm	not set for DSGapH
	//	min_alarm	not set for DSGapH
	//	max_warning	not set for DSGapH
	//	min_warning	not set for DSGapH
	//	delta_t	not set for DSGapH
	//	delta_val	not set for DSGapH
	
	dsgaph->set_default_properties(dsgaph_prop);
	//	Not Polled
	dsgaph->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dsgaph);

	//	Attribute : DSGapV
	DSGapVAttrib	*dsgapv = new DSGapVAttrib();
	Tango::UserDefaultAttrProp	dsgapv_prop;
	//	description	not set for DSGapV
	//	label	not set for DSGapV
	//	unit	not set for DSGapV
	//	standard_unit	not set for DSGapV
	//	display_unit	not set for DSGapV
	//	format	not set for DSGapV
	//	max_value	not set for DSGapV
	//	min_value	not set for DSGapV
	//	max_alarm	not set for DSGapV
	//	min_alarm	not set for DSGapV
	//	max_warning	not set for DSGapV
	//	min_warning	not set for DSGapV
	//	delta_t	not set for DSGapV
	//	delta_val	not set for DSGapV
	
	dsgapv->set_default_properties(dsgapv_prop);
	//	Not Polled
	dsgapv->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dsgapv);

	//	Attribute : DSAxisIsInitialised
	DSAxisIsInitialisedAttrib	*dsaxisisinitialised = new DSAxisIsInitialisedAttrib();
	Tango::UserDefaultAttrProp	dsaxisisinitialised_prop;
	//	description	not set for DSAxisIsInitialised
	//	label	not set for DSAxisIsInitialised
	//	unit	not set for DSAxisIsInitialised
	//	standard_unit	not set for DSAxisIsInitialised
	//	display_unit	not set for DSAxisIsInitialised
	//	format	not set for DSAxisIsInitialised
	//	max_value	not set for DSAxisIsInitialised
	//	min_value	not set for DSAxisIsInitialised
	//	max_alarm	not set for DSAxisIsInitialised
	//	min_alarm	not set for DSAxisIsInitialised
	//	max_warning	not set for DSAxisIsInitialised
	//	min_warning	not set for DSAxisIsInitialised
	//	delta_t	not set for DSAxisIsInitialised
	//	delta_val	not set for DSAxisIsInitialised
	
	dsaxisisinitialised->set_default_properties(dsaxisisinitialised_prop);
	dsaxisisinitialised->set_polling_period(1000);
	dsaxisisinitialised->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dsaxisisinitialised);

	//	Attribute : History
	HistoryAttrib	*history = new HistoryAttrib();
	Tango::UserDefaultAttrProp	history_prop;
	//	description	not set for History
	//	label	not set for History
	//	unit	not set for History
	//	standard_unit	not set for History
	//	display_unit	not set for History
	//	format	not set for History
	//	max_value	not set for History
	//	min_value	not set for History
	//	max_alarm	not set for History
	//	min_alarm	not set for History
	//	max_warning	not set for History
	//	min_warning	not set for History
	//	delta_t	not set for History
	//	delta_val	not set for History
	
	history->set_default_properties(history_prop);
	//	Not Polled
	history->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(history);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(DsAxisClass::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void DsAxisClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(DsAxisClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::pipe_factory_before
	/*----- PROTECTED REGION ID(DsAxisClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void DsAxisClass::command_factory()
{
	/*----- PROTECTED REGION ID(DsAxisClass::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::command_factory_before


	//	Command AxisStopH1
	AxisStopH1Class	*pAxisStopH1Cmd =
		new AxisStopH1Class("AxisStopH1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopH1Cmd);

	//	Command AxisStopV1
	AxisStopV1Class	*pAxisStopV1Cmd =
		new AxisStopV1Class("AxisStopV1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopV1Cmd);

	//	Command AxisStopH2
	AxisStopH2Class	*pAxisStopH2Cmd =
		new AxisStopH2Class("AxisStopH2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopH2Cmd);

	//	Command AxisStopV2
	AxisStopV2Class	*pAxisStopV2Cmd =
		new AxisStopV2Class("AxisStopV2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisStopV2Cmd);

	//	Command AxisInitH1
	AxisInitH1Class	*pAxisInitH1Cmd =
		new AxisInitH1Class("AxisInitH1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitH1Cmd);

	//	Command AxisInitV1
	AxisInitV1Class	*pAxisInitV1Cmd =
		new AxisInitV1Class("AxisInitV1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitV1Cmd);

	//	Command AxisInitH2
	AxisInitH2Class	*pAxisInitH2Cmd =
		new AxisInitH2Class("AxisInitH2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitH2Cmd);

	//	Command AxisInitV2
	AxisInitV2Class	*pAxisInitV2Cmd =
		new AxisInitV2Class("AxisInitV2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pAxisInitV2Cmd);

	//	Command MotorOnH1
	MotorOnH1Class	*pMotorOnH1Cmd =
		new MotorOnH1Class("MotorOnH1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOnH1Cmd);

	//	Command MotorOnV1
	MotorOnV1Class	*pMotorOnV1Cmd =
		new MotorOnV1Class("MotorOnV1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOnV1Cmd);

	//	Command MotorOnH2
	MotorOnH2Class	*pMotorOnH2Cmd =
		new MotorOnH2Class("MotorOnH2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOnH2Cmd);

	//	Command MotorOnV2
	MotorOnV2Class	*pMotorOnV2Cmd =
		new MotorOnV2Class("MotorOnV2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOnV2Cmd);

	//	Command MotorOffH1
	MotorOffH1Class	*pMotorOffH1Cmd =
		new MotorOffH1Class("MotorOffH1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOffH1Cmd);

	//	Command MotorOffV1
	MotorOffV1Class	*pMotorOffV1Cmd =
		new MotorOffV1Class("MotorOffV1",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOffV1Cmd);

	//	Command MotorOffH2
	MotorOffH2Class	*pMotorOffH2Cmd =
		new MotorOffH2Class("MotorOffH2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOffH2Cmd);

	//	Command MotorOffV2
	MotorOffV2Class	*pMotorOffV2Cmd =
		new MotorOffV2Class("MotorOffV2",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pMotorOffV2Cmd);

	//	Command GetMotionStatusH1
	GetMotionStatusH1Class	*pGetMotionStatusH1Cmd =
		new GetMotionStatusH1Class("GetMotionStatusH1",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetMotionStatusH1Cmd);

	//	Command GetMotionStatusV1
	GetMotionStatusV1Class	*pGetMotionStatusV1Cmd =
		new GetMotionStatusV1Class("GetMotionStatusV1",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetMotionStatusV1Cmd);

	//	Command GetMotionStatusH2
	GetMotionStatusH2Class	*pGetMotionStatusH2Cmd =
		new GetMotionStatusH2Class("GetMotionStatusH2",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetMotionStatusH2Cmd);

	//	Command GetMotionStatusV2
	GetMotionStatusV2Class	*pGetMotionStatusV2Cmd =
		new GetMotionStatusV2Class("GetMotionStatusV2",
			Tango::DEV_VOID, Tango::DEV_LONG,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetMotionStatusV2Cmd);

	//	Command DSCenterHGoToPosition
	DSCenterHGoToPositionClass	*pDSCenterHGoToPositionCmd =
		new DSCenterHGoToPositionClass("DSCenterHGoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSCenterHGoToPositionCmd);

	//	Command DSCenterVGoToPosition
	DSCenterVGoToPositionClass	*pDSCenterVGoToPositionCmd =
		new DSCenterVGoToPositionClass("DSCenterVGoToPosition",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSCenterVGoToPositionCmd);

	//	Command DSGapH
	DSGapHClass	*pDSGapHCmd =
		new DSGapHClass("DSGapH",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSGapHCmd);

	//	Command DSGapV
	DSGapVClass	*pDSGapVCmd =
		new DSGapVClass("DSGapV",
			Tango::DEV_DOUBLE, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSGapVCmd);

	//	Command DSAxisStop
	DSAxisStopClass	*pDSAxisStopCmd =
		new DSAxisStopClass("DSAxisStop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSAxisStopCmd);

	//	Command DSAxisInit
	DSAxisInitClass	*pDSAxisInitCmd =
		new DSAxisInitClass("DSAxisInit",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pDSAxisInitCmd);

	/*----- PROTECTED REGION ID(DsAxisClass::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		DsAxisClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void DsAxisClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(DsAxisClass::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		DsAxisClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void DsAxisClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		DsAxis *dev = static_cast<DsAxis *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(DsAxisClass::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : DsAxisClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *DsAxisClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(DsAxisClass::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	DsAxisClass::Additional Methods
} //	namespace
