/*
 * DsAxisHandler.h
 *
 *  Created on: Mar 23, 2012
 *      Author: mdm
 */

#ifndef DSAXISHANDLER_H_
#define DSAXISHANDLER_H_

#include <tango.h>

namespace DsAxis_ns
{

class DsAxis;

class DsAxisHandler
{

public:
	DsAxisHandler(std::string, Tango::DevULong, std::string, std::string) throw(Tango::DevFailed);
	virtual ~DsAxisHandler();

	virtual void update_attributes() throw(Tango::DevFailed);

	virtual Tango::DevState get_state();
	virtual std::string get_status();
	virtual Tango::DevShort is_initialised();

	virtual void axis_init() throw(Tango::DevFailed);
	virtual void axis_stop() throw(Tango::DevFailed);
	virtual void motor_on() throw(Tango::DevFailed);
	virtual void motor_off() throw(Tango::DevFailed);

	virtual Tango::DevDouble read_position() throw(Tango::DevFailed);
	virtual void write_position(Tango::DevDouble) throw(Tango::DevFailed);

	virtual Tango::DevLong get_motion_status() throw(Tango::DevFailed);
	virtual Tango::DevDouble get_motion_accuracy() throw(Tango::DevFailed);

private:
	Tango::DeviceProxy* axis_proxy;

        string  positionAttribute;
        string  motionAccuracyAttribute;


	omni_mutex mutex;

	Tango::DevState axis_state;
	std::string axis_status;
	Tango::DevShort axis_initialised;
};

}	//name space

#endif /* DSAXISHANDLER_H_ */
