/*----- PROTECTED REGION ID(DsAxisStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        DsAxisStateMachine.cpp
//
// description : State machine file for the DsAxis class
//
// project :     DsAxis
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <DsAxis.h>
#include <DsAxisClass.h>
#include "DsAxisHandler.h"

/*----- PROTECTED REGION END -----*/	//	DsAxis::DsAxisStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  OFF      |  
//  STANDBY  |  
//  MOVING   |  
//  ALARM    |  
//  FAULT    |  


namespace DsAxis_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisPositionH1_allowed()
 *	Description : Execution allowed for AxisPositionH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisPositionH1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisPositionH1 attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionH1StateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if( get_state() == Tango::FAULT)            return false;
                if( !h1_axis->is_initialised() )            return false;
                if( h1_axis->get_state() == Tango::MOVING ) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionH1StateAllowed_WRITE

	//	Not any excluded states for AxisPositionH1 attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionH1StateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h1_axis->is_initialised() ) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionH1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisPositionH2_allowed()
 *	Description : Execution allowed for AxisPositionH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisPositionH2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisPositionH2 attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionH2StateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h2_axis->is_initialised() ) return false;
                if( h2_axis->get_state() == Tango::MOVING ) return false; 
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionH2StateAllowed_WRITE

	//	Not any excluded states for AxisPositionH2 attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionH2StateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h2_axis->is_initialised() ) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionH2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisPositionV1_allowed()
 *	Description : Execution allowed for AxisPositionV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisPositionV1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisPositionV1 attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionV1StateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() ) return false;
                if( v1_axis->get_state() == Tango::MOVING ) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionV1StateAllowed_WRITE

	//	Not any excluded states for AxisPositionV1 attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionV1StateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() ) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionV1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisPositionV2_allowed()
 *	Description : Execution allowed for AxisPositionV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisPositionV2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for AxisPositionV2 attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionV2StateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v2_axis->is_initialised() ) return false;
                if( v2_axis->get_state() == Tango::MOVING ) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionV2StateAllowed_WRITE

	//	Not any excluded states for AxisPositionV2 attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::AxisPositionV2StateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v2_axis->is_initialised() ) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisPositionV2StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_IsInitialisedH1_allowed()
 *	Description : Execution allowed for IsInitialisedH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_IsInitialisedH1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(DsAxis::IsInitialisedH1StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DsAxis::IsInitialisedH1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_IsInitialisedH2_allowed()
 *	Description : Execution allowed for IsInitialisedH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_IsInitialisedH2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(DsAxis::IsInitialisedH2StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DsAxis::IsInitialisedH2StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_IsInitialisedV1_allowed()
 *	Description : Execution allowed for IsInitialisedV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_IsInitialisedV1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(DsAxis::IsInitialisedV1StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DsAxis::IsInitialisedV1StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_IsInitialisedV2_allowed()
 *	Description : Execution allowed for IsInitialisedV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_IsInitialisedV2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ 
		if (get_state()==Tango::FAULT)
		{
		/*----- PROTECTED REGION ID(DsAxis::IsInitialisedV2StateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DsAxis::IsInitialisedV2StateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSCenterH_allowed()
 *	Description : Execution allowed for DSCenterH attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSCenterH_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DSCenterH attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterHStateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
                if(h1_axis->get_state() == Tango::MOVING || h2_axis->get_state() == Tango::MOVING) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterHStateAllowed_WRITE

	//	Not any excluded states for DSCenterH attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterHStateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterHStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSCenterV_allowed()
 *	Description : Execution allowed for DSCenterV attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSCenterV_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DSCenterV attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterVStateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
                if(v1_axis->get_state() == Tango::MOVING || v2_axis->get_state() == Tango::MOVING) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterVStateAllowed_WRITE

	//	Not any excluded states for DSCenterV attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterVStateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterVStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSGapH_allowed()
 *	Description : Execution allowed for DSGapH attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSGapH_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DSGapH attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::DSGapHStateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
                if(h1_axis->get_state() == Tango::MOVING || h2_axis->get_state() == Tango::MOVING) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapHStateAllowed_WRITE

	//	Not any excluded states for DSGapH attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::DSGapHStateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapHStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSGapV_allowed()
 *	Description : Execution allowed for DSGapV attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSGapV_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for DSGapV attribute in Write access.
	/*----- PROTECTED REGION ID(DsAxis::DSGapVStateAllowed_WRITE) ENABLED START -----*/
        if ( type!=Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
                if(v1_axis->get_state() == Tango::MOVING || v2_axis->get_state() == Tango::MOVING) return false;
                return true;
        }
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapVStateAllowed_WRITE

	//	Not any excluded states for DSGapV attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::DSGapVStateAllowed_READ) ENABLED START -----*/
        if ( type==Tango::READ_REQ ) {
                if(get_state() == Tango::FAULT) return false;
                if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
	}
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapVStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSAxisIsInitialised_allowed()
 *	Description : Execution allowed for DSAxisIsInitialised attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSAxisIsInitialised_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for DSAxisIsInitialised attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::DSAxisIsInitialisedStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	DsAxis::DSAxisIsInitialisedStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_History_allowed()
 *	Description : Execution allowed for History attribute
 */
//--------------------------------------------------------
bool DsAxis::is_History_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for History attribute in read access.
	/*----- PROTECTED REGION ID(DsAxis::HistoryStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::HistoryStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisStopH1_allowed()
 *	Description : Execution allowed for AxisStopH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisStopH1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisStopH1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisStopH1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisStopV1_allowed()
 *	Description : Execution allowed for AxisStopV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisStopV1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisStopV1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisStopV1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisStopH2_allowed()
 *	Description : Execution allowed for AxisStopH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisStopH2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisStopH2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisStopH2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisStopV2_allowed()
 *	Description : Execution allowed for AxisStopV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisStopV2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisStopV2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisStopV2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisInitH1_allowed()
 *	Description : Execution allowed for AxisInitH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisInitH1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisInitH1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisInitH1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisInitV1_allowed()
 *	Description : Execution allowed for AxisInitV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisInitV1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisInitV1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisInitV1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisInitH2_allowed()
 *	Description : Execution allowed for AxisInitH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisInitH2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisInitH2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisInitH2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_AxisInitV2_allowed()
 *	Description : Execution allowed for AxisInitV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_AxisInitV2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::AxisInitV2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::AxisInitV2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOnH1_allowed()
 *	Description : Execution allowed for MotorOnH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOnH1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOnH1StateAllowed) ENABLED START -----*/
	
                if(get_state() == Tango::ALARM && h1_axis->is_initialised()) return true;

	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOnH1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOnV1_allowed()
 *	Description : Execution allowed for MotorOnV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOnV1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOnV1StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && v1_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOnV1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOnH2_allowed()
 *	Description : Execution allowed for MotorOnH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOnH2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOnH2StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && h2_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOnH2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOnV2_allowed()
 *	Description : Execution allowed for MotorOnV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOnV2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOnV2StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && v2_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOnV2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOffH1_allowed()
 *	Description : Execution allowed for MotorOffH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOffH1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOffH1StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && h1_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOffH1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOffV1_allowed()
 *	Description : Execution allowed for MotorOffV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOffV1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOffV1StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && v1_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOffV1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOffH2_allowed()
 *	Description : Execution allowed for MotorOffH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOffH2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOffH2StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && h2_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOffH2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_MotorOffV2_allowed()
 *	Description : Execution allowed for MotorOffV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_MotorOffV2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::ALARM ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::MotorOffV2StateAllowed) ENABLED START -----*/

                if(get_state() == Tango::ALARM && v2_axis->is_initialised()) return true;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::MotorOffV2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_GetMotionStatusH1_allowed()
 *	Description : Execution allowed for GetMotionStatusH1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_GetMotionStatusH1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::GetMotionStatusH1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::GetMotionStatusH1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_GetMotionStatusV1_allowed()
 *	Description : Execution allowed for GetMotionStatusV1 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_GetMotionStatusV1_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::GetMotionStatusV1StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::GetMotionStatusV1StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_GetMotionStatusH2_allowed()
 *	Description : Execution allowed for GetMotionStatusH2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_GetMotionStatusH2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::GetMotionStatusH2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::GetMotionStatusH2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_GetMotionStatusV2_allowed()
 *	Description : Execution allowed for GetMotionStatusV2 attribute
 */
//--------------------------------------------------------
bool DsAxis::is_GetMotionStatusV2_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::GetMotionStatusV2StateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::GetMotionStatusV2StateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSCenterHGoToPosition_allowed()
 *	Description : Execution allowed for DSCenterHGoToPosition attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSCenterHGoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DSCenterHGoToPosition command.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterHGoToPositionStateAllowed) ENABLED START -----*/

        if(get_state() == Tango::FAULT) return false;
        if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
        if(h1_axis->get_state() == Tango::MOVING || h2_axis->get_state() == Tango::MOVING) return false;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterHGoToPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSCenterVGoToPosition_allowed()
 *	Description : Execution allowed for DSCenterVGoToPosition attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSCenterVGoToPosition_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DSCenterVGoToPosition command.
	/*----- PROTECTED REGION ID(DsAxis::DSCenterVGoToPositionStateAllowed) ENABLED START -----*/

        if(get_state() == Tango::FAULT) return false;
        if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
        if(v1_axis->get_state() == Tango::MOVING || v2_axis->get_state() == Tango::MOVING) return false;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSCenterVGoToPositionStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSGapH_allowed()
 *	Description : Execution allowed for DSGapH attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSGapH_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DSGapH command.
	/*----- PROTECTED REGION ID(DsAxis::DSGapHStateAllowed) ENABLED START -----*/

        if(get_state() == Tango::FAULT) return false;
        if( !h1_axis->is_initialised() || !h2_axis->is_initialised()) return false;
        if(h1_axis->get_state() == Tango::MOVING || h2_axis->get_state() == Tango::MOVING) return false;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapHStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSGapV_allowed()
 *	Description : Execution allowed for DSGapV attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSGapV_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for DSGapV command.
	/*----- PROTECTED REGION ID(DsAxis::DSGapVStateAllowed) ENABLED START -----*/

        if(get_state() == Tango::FAULT) return false; 
        if( !v1_axis->is_initialised() || !v2_axis->is_initialised()) return false;
        if(v1_axis->get_state() == Tango::MOVING || v2_axis->get_state() == Tango::MOVING) return false;
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSGapVStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSAxisStop_allowed()
 *	Description : Execution allowed for DSAxisStop attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSAxisStop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::DSAxisStopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSAxisStopStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : DsAxis::is_DSAxisInit_allowed()
 *	Description : Execution allowed for DSAxisInit attribute
 */
//--------------------------------------------------------
bool DsAxis::is_DSAxisInit_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::MOVING ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(DsAxis::DSAxisInitStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	DsAxis::DSAxisInitStateAllowed
		return false;
	}
	return true;
}


/*----- PROTECTED REGION ID(DsAxis::DsAxisStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	DsAxis::DsAxisStateAllowed.AdditionalMethods

}	//	End of namespace
